#!/usr/bin/env python 
"""
Copyright (C) 2009 Nick Drobchenko, nick@cnc-club.ru
based on gcode.py (C) 2007 hugomatic... 
based on addnodes.py (C) 2005,2007 Aaron Spike, aaron@ekips.org
based on dots.py (C) 2005 Aaron Spike, aaron@ekips.org

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""

#	
#	This extension close paths by adding 'z' before each 'm' if it is not
#	the first 'm' and it is not prepended by 'z' already.
#

import inkex, re, cubicsuperpath


def area(p1,p2,p3) :
	return abs(   p1[0]*(p2[1]-p3[1]) + p2[0]*(p3[1]-p1[1]) + p3[0]*(p1[1]-p2[1])   )/2
			
class CloseCurves(inkex.Effect):
	def __init__(self):
		inkex.Effect.__init__(self)
		self.OptionParser.add_option("-f", "--tolerance",					action="store", type="float", 		dest="tolerance", default=".01")			
		self.OptionParser.add_option("-i", "--info",						action="store", type="inkbool", 		dest="info", default=True)

	def effect(self):
		info = {}
		for id, node in self.selected.iteritems():
			if node.tag == inkex.addNS('path','svg'):
				if "d" not in node.keys() : 
					inkex.errormsg("Warning: One or more paths do not have 'd' parameter, try to Ungroup (Ctrl+Shift+G) and Object to Path (Ctrl+Shift+C)!"+"\n")		
					continue
				csp = cubicsuperpath.parsePath(node.get('d'))
				id_ = node.get("id")
				info[id_] = []
				j = 0
				while j< len(csp) :
					sub_csp = csp[j]
					l0 = len(sub_csp)
					done_smf = True
					while done_smf :
						done_smf = False
						if len(sub_csp)<3 : 
							break
						i = 0 
						while i<len(sub_csp)-3:
							s = area(sub_csp[i][1],sub_csp[i+1][1],sub_csp[i+2][1])
							if s <	self.options.tolerance :						
								sub_csp = sub_csp[:i+1]+sub_csp[i+2:]
								done_smf = True
							i += 1
					csp[j] = sub_csp
					info[id].append([l0,len(sub_csp)])
					j += 1	

				d =  cubicsuperpath.formatPath(csp)
				node.set("d",d)
				if self.options.info :
					s1 = sum([ k[0] for k in info[id_] ])	
					s2 = sum([ k[1] for k in info[id_] ])	
					inkex.errormsg("Path %s %d - %d = %d"%(id_,s1,s1-s2,s2)+"\n")		

		if self.options.info :
			s1 = sum([ sum([ k[0] for k in info[id_] ]) for id_ in info	])
			s1 = sum([ sum([ k[1] for k in info[id_] ]) for id_ in info	])
			inkex.errormsg("TOTAL %s %d - %d = %d"%(id_,s1,s1-s2,s2)+"\n")		



	
e = CloseCurves()
e.affect()
























